Page MenuHomePhabricator

Deploy The Wikipedia Library Echo notification
Closed, ResolvedPublic

Description

The Wikipedia Library Echo notification (T132084) is ready for deployment, and will be rolled out with a gradually decreasing edit count requirement for receiving it. This is because, per T271962, approximately 40,000 editors may receive this notification in the first week if it was deployed with the target requirements and we don't want to substantially degrade tool performance.

Pending any issues or bugs, we will follow this deployment plan:

Week of...ProjectsEdit count thresholdApproximate number of editors receiving notificationDone?
6th NovemberMeta and Test only50,000Unknown (low)*X
Testing and holiday break
10th JanuaryAll50,0005,249X
18th JanuaryAll10,0009,862X
24th JanuaryAll2,00012,259X
31st JanuaryAll50011,771X

*Subsequent analysis shows this number was approximately 500-1000.

Extension page: https://www.mediawiki.org/wiki/Extension:TheWikipediaLibrary

The notification has been deployed in its current state on Beta since May 2021.

Related Objects

Event Timeline

There are a very large number of changes, so older changes are hidden. Show Older Changes

@Samwalton9 After asking some basic questions of the folks in release engineering, it sounds like this should be pretty straightforward to deploy and configure across all the WMF projects simultaneously. My takeway is that requesting the deployment date/time is our next step, so we need to either complete T240128 or have firm date on it to move forward here.

@Scardenasmolinar or I will need to be available during the deployment window, and I'm happy to be that person. Since we're both in the Central tz, the time of day would be the same for us either way.

It might be a good idea for the point person to go through the prerequisites and signup for the next us config and backport training (https://wikitech.wikimedia.org/wiki/Deployments#deploycal-item-20210812T2300) so that we can come into this less rusty.

@jsn.sherman Thanks for looking into this!

My takeway is that requesting the deployment date/time is our next step, so we need to either complete T240128 or have firm date on it to move forward here.

That task is really the only firm prerequisite - do you know how far in advance we need to request the deployment timing?

Quick update: We're waiting on the results of T279048 before we set dates for this.

@jsn.sherman or @Scardenasmolinar can you check that the configuration is set to 50,000 edits ready for deployment?

@greg After that potential config update we think this is ready to deploy to Production, next week at the earliest. What would the next steps be?

We've updated the editcount requirement to 50,000.

@greg After that potential config update we think this is ready to deploy to Production, next week at the earliest. What would the next steps be?

Hi there, sorry for the late reply, I don't always see my Phab notifications :)

Generally, following https://www.mediawiki.org/wiki/Writing_an_extension_for_deployment is good as it has the documentation for this. Notably, thanks for already adding it to https://www.mediawiki.org/wiki/Developers/Maintainers :)

Let me know if you have any questions about anything else from the wiki page list of things to do (full disclosure, I didn't do a review of what was done/not done other than [[Dev/Maintainers]], if you want to create a checklist in this task or a set of sub-tasks that makes it easier).

@greg After that potential config update we think this is ready to deploy to Production, next week at the earliest. What would the next steps be?

Hi there, sorry for the late reply, I don't always see my Phab notifications :)

Generally, following https://www.mediawiki.org/wiki/Writing_an_extension_for_deployment is good as it has the documentation for this. Notably, thanks for already adding it to https://www.mediawiki.org/wiki/Developers/Maintainers :)

Let me know if you have any questions about anything else from the wiki page list of things to do (full disclosure, I didn't do a review of what was done/not done other than [[Dev/Maintainers]], if you want to create a checklist in this task or a set of sub-tasks that makes it easier).

No problem. We've been following that guide, and are confident we've done everything we need to. The page notes that "Once an extension has made it through reviews, then the extension can be scheduled for deployment by the Wikimedia Foundation Release Manager". We're happy for this to be deployed any time, so can this be scheduled?

No problem. We've been following that guide, and are confident we've done everything we need to.

Is that documented somewhere? Usually folks create sub-tasks of the main deployment task for all/many of the bits. It makes it immensely easier for us to review and schedule.

No problem. We've been following that guide, and are confident we've done everything we need to.

Is that documented somewhere? Usually folks create sub-tasks of the main deployment task for all/many of the bits. It makes it immensely easier for us to review and schedule.

Ah - I tried to include everything in this ticket description, but more specifically:

  • A review from the product owner for the affected area, if applicable. If you are unsure who that might be, it is likely a good idea to reach out to various engineering teams within the Product or Technology verticals for more information and guidance.

I approve of this as PO for the notification destination. Echo itself isn't actively under development but is apparently maintained by the Growth-Team - if necessary I could also get approval from that team?

  • A design review, if applicable.

Not applicable, the only design element here is the icon and text.

  • A beta feature review, if your extension adds a beta feature.

N/A

  • A security readiness review: to open a request create a security readiness review task and mark it as a subtask of the production deployment tracking task (via "Edit Task" in the upper right corner). A security readiness review can be a blocker for production deployment depending upon the details of the request and its results.

T207990

  • A security review for any new external dependencies which should then be added to mediawiki/vendor. Here is a basic list the Security Team typically checks when reviewing third party/vendor code.

N/A

  • A performance review. This review is typically not a blocker for production deployment.

T275774

  • If you have reasons to think that a database review is needed, create a request in Phabricator.

N/A

Hey @greg, we really appreciate your help with this. This is the team's first time deploying a config change (to enable an extension). It's basically the first time we deploy anything. And we want to make sure we follow the process and nothing goes wrong.

Change 736863 had a related patch set uploaded (by Jsn.sherman; author: Jsn.sherman):

[operations/mediawiki-config@master] Enable TheWikipediaLibrary on all wikis

https://gerrit.wikimedia.org/r/736863

Based on feedback in IRC, I set this to only be enabled on meta and testwiki. It was suggested that going from labs to all wikis might be too big of a change.

Change 736863 merged by jenkins-bot:

[operations/mediawiki-config@master] Enable TheWikipediaLibrary on meta & testwiki

https://gerrit.wikimedia.org/r/736863

Mentioned in SAL (#wikimedia-operations) [2021-11-08T19:58:13Z] <urbanecm@deploy1002> Synchronized wmf-config/InitialiseSettings.php: e66bd53b54ee29423affcba768b7a3cf1a81714a: Enable TheWikipediaLibrary on meta & testwiki (T288070) (duration: 00m 55s)

Quick update: We think we've resolved the outstanding bugs and issues raised by our initial deployment. Once T295621 has been merged, we'll proceed with the next step of deployment, opening this up to users on all Wikimedia projects with more than 50,000 edits.

Change 742996 had a related patch set uploaded (by Jsn.sherman; author: Jsn.sherman):

[operations/mediawiki-config@master] Enable TheWikipediaLibrary on all wikis

https://gerrit.wikimedia.org/r/742996

@Reedy under your recommendation, we initially rolled this out to only meta and testwiki a few weeks back, where we got some great feedback that we have incorporated into the extension. We think we're ready to deploy to all projects pending the deployment of 1.38.0-wmf.12 across all groups. Given that your advice ahead of the last deployment was 100% on the nose, I thought I'd ask: does this seem reasonable?

For now, I put a -1 on that config change since we're blocked on the train and pending any feedback from you.

pulled us off the backport window for today because the train is blocked, see T293953

We missed our backport window due to the train issues, and its now getting close to holiday time for the team, so we've pushed this back to the week following the WMF break.

We missed our backport window due to the train issues, and its now getting close to holiday time for the team, so we've pushed this back to the week following the WMF break.

:(

@jsn.sherman Is there a good backport window for us to continue rolling this out this week?

This comment was removed by jsn.sherman.

@Samwalton9 Currently planning on rolling out next monday:
https://wikitech.wikimedia.org/wiki/Deployments#deploycal-item-20220110T1900
removed original comment in an untemp to "undo" an accidental mention of another task.

Change 742996 merged by jenkins-bot:

[operations/mediawiki-config@master] Enable TheWikipediaLibrary on most wikis

https://gerrit.wikimedia.org/r/742996

Mentioned in SAL (#wikimedia-operations) [2022-01-10T19:27:05Z] <urbanecm@deploy1002> Synchronized wmf-config/InitialiseSettings.php: 8f5ca9af5ef04d1d19759cdf201fc0c7e4ee6fbc: Enable TheWikipediaLibrary on most wikis (T288070) (duration: 01m 00s)

Change 754054 had a related patch set uploaded (by Scardenasmolinar; author: Scardenasmolinar):

[operations/mediawiki-config@master] Change TheWikipediaLibrary editcount

https://gerrit.wikimedia.org/r/754054

Change 754054 merged by jenkins-bot:

[operations/mediawiki-config@master] Change TheWikipediaLibrary editcount

https://gerrit.wikimedia.org/r/754054

Mentioned in SAL (#wikimedia-operations) [2022-01-19T00:49:28Z] <catrope@deploy1002> Synchronized wmf-config/InitialiseSettings.php: Config: [[gerrit:754054|Change TheWikipediaLibrary editcount (T288070)]] (duration: 00m 53s)

Samwalton9 renamed this task from Deploy The Wikipedia Library Echo notification with 50,000 edit count threshold to Deploy The Wikipedia Library Echo notification.Jan 19 2022, 10:34 AM
Samwalton9 updated the task description. (Show Details)
Samwalton9 updated the task description. (Show Details)
Samwalton9 updated the task description. (Show Details)

Change 758033 had a related patch set uploaded (by Scardenasmolinar; author: Scardenasmolinar):

[operations/mediawiki-config@master] Lower The Wikipedia Library extension edit count

https://gerrit.wikimedia.org/r/758033

Change 758033 merged by jenkins-bot:

[operations/mediawiki-config@master] Lower The Wikipedia Library extension edit count

https://gerrit.wikimedia.org/r/758033

Mentioned in SAL (#wikimedia-operations) [2022-02-01T00:11:54Z] <catrope@deploy1002> Synchronized wmf-config/InitialiseSettings.php: Config: [[gerrit:758033|Lower The Wikipedia Library extension edit count (T288070)]] (duration: 00m 50s)

Now that the extension has finished rolling out, I will park this task in the Review column

Samwalton9 claimed this task.

This is rolled out to all users with 500+ edits and seems to be working as intended!